#ifndef STATIC_MUTEX_H
#define STATIC_MUTEX_H

#include "config.h"
#include "problem.h"
// #include "stats.h"

BEGIN_HSPS_NAMESPACE

// implementation of h^2 optimised for static mutex
// calculation (i.e., all zero-cost actions)

class StaticMutex {
  Instance& instance;
  s2index   pairix;
  bool_vec  tab;

  void compute();

 public:
  StaticMutex(Instance& ins);

  // eval returns "true" for NON-MUTEX pairs/sets
  bool eval(index_type i, index_type j) const;
  bool eval(const index_set& s) const;
  bool eval(const index_set& s, index_type i) const;
  bool eval(const index_set& s1, const index_set& s2) const;

  bool mutex(index_type i, index_type j) const {
    return !eval(i, j);
  }

  bool mutex(const index_set& s) const {
    return !eval(s);
  }

  bool mutex(const index_set& s, index_type i) const {
    return !eval(s, i);
  }

  bool mutex(const index_set& s1, const index_set& s2) const {
    return !eval(s1, s2);
  }
};

END_HSPS_NAMESPACE

#endif
